using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.ComponentModel;
using System.Diagnostics;

namespace AsyncDataBinding
{
    class MySource : INotifyPropertyChanged
    {
        private string dataValue;

        public string Data
        {
            get
            {
                Debug.WriteLine("Read thread: " + Thread.CurrentThread.ManagedThreadId);
                return dataValue;
            }
            set
            {
                if (value != dataValue)
                {
                    dataValue = value;

                    PropertyChangedEventHandler handler;
                    lock (this)
                    {
                        handler = PropertyChanged;
                    }
                    if (handler != null)
                    {
                        Debug.WriteLine("Change notification thread: " + Thread.CurrentThread.ManagedThreadId);
                        handler(this, new PropertyChangedEventArgs("Data"));
                    }
                }
            }
        }

        int count = 1;
        public void ReadNewData()
        {
            ThreadPool.QueueUserWorkItem(delegate
            {
                Thread.Sleep(5000);
                Data = "Item " + count;
                count += 1;
            });
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
