using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections.ObjectModel;


namespace DataBindingDemo
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>

    public partial class Window1 : System.Windows.Window
    {
        Person source;
        ObservableCollection<Person> sourceList = new ObservableCollection<Person>();

        public Window1()
        {
            InitializeComponent();

            source = new Person("Ian", 33.5);

            sourceList.Add(source);
            sourceList.Add(new Person("Dave", 36.2));
            sourceList.Add(new Person("Bill", 52.3));

            this.DataContext = sourceList;

            showDataButton.Click += new RoutedEventHandler(showDataButton_Click);
            getOlderButton.Click += new RoutedEventHandler(getOlderButton_Click);
            addPersonButton.Click += new RoutedEventHandler(addPersonButton_Click);
        }

        void addPersonButton_Click(object sender, RoutedEventArgs e)
        {
            sourceList.Add(new Person("Arthur", 23.4));
        }

        void getOlderButton_Click(object sender, RoutedEventArgs e)
        {
            source.Age += 1;
            //ageText.GetBindingExpression(TextBox.TextProperty).UpdateTarget();
        }

        void showDataButton_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Name: " + source.Name + ", Age: " + source.Age,
                "Data");
        }

    }
}